PD = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0")
local frame, damag, statone, typed
local a, cd, cs, ct, da, dn, dt, f, x, y, p1, p2, s1, s2, h, v, t
if GetAddOnInfo("LibSharedMedia-2.0") then EnableAddOn("LibSharedMedia-2.0") LoadAddOn("LibSharedMedia-2.0") end
local SharedMedia = LibStub and LibStub:GetLibrary("LibSharedMedia-2.0", true)
local L = setmetatable({}, { __index = function(self, key) rawset(self, key, key) return key end }) PD.L = L

function PD:OnInitialize()
	self:RegisterDB("pddb", "pdChardb")
	self:RegisterDefaults('profile', {
		alignH = "CENTER",
		alignV = "TOP",
		colorDamag = { r = 255/255, g = 255/255, b = 255/255, },
		colorTyped = { r = 255/255, g = 255/255, b = 255/255, },
		colorStats = { r = 255/255, g = 255/255, b = 255/255, },
		fontFace = "Friz Quadrata TT",
		fontSizeDamag = 32,
		fontSizeTyped = 16,
		fontSizeStats = 12,
		pos = "CENTER",
		rpos = "CENTER",
		posX = 0, 
		posY = 0,
		locked = false
	})
	self:RegisterDefaults('char', {
		damtype = "0",
		statone = "0",
		stattwo = "0"
	})
	self:LoadOptions()
end

function PD:UpdateText()
	if self.db.char.damtype == "1" then dn = "Physical Power" dt = GetSpellBonusDamage(1)
	elseif self.db.char.damtype == "2" then dn = "Holy Damage" dt = GetSpellBonusDamage(2)
	elseif self.db.char.damtype == "3" then dn = "Fire Damage" dt = GetSpellBonusDamage(3)
	elseif self.db.char.damtype == "4" then dn = "Nature Damage" dt = GetSpellBonusDamage(4)
	elseif self.db.char.damtype == "5" then dn = "Frost Damage" dt = GetSpellBonusDamage(5)
	elseif self.db.char.damtype == "6" then dn = "Shadow Damage" dt = GetSpellBonusDamage(6)
	elseif self.db.char.damtype == "7" then dn = "Arcane Damage" dt = GetSpellBonusDamage(7)
	elseif self.db.char.damtype == "8" then dn = "Healing Power" dt = GetSpellBonusHealing()
	elseif self.db.char.damtype == "9" then dn = "Attack Power" local base, posBuff, negBuff = UnitAttackPower("player") dt = base + posBuff + negBuff
	elseif self.db.char.damtype == "10" then dn = "Ranged AP" local base, posBuff, negBuff = UnitRangedAttackPower("player") dt = base + posBuff + negBuff
	end

	s1 = self:UpdateStats(self.db.char.statone)
	s2 = self:UpdateStats(self.db.char.stattwo)
	
	damag:SetText( dt )
	typed:SetText( dn )
	statone:SetText( s1 )
	stattwo:SetText( s2 )
end

function PD:UpdateStats(line)
	if line == "0" then var = ""
	elseif line == "1" then local _,total,_,_ = UnitResistance("player",0) var = total.." armor"
	elseif line == "2" then local _,total,_,_ = UnitResistance("player",1) var = total.." Holy resistance"
	elseif line == "3" then local _,total,_,_ = UnitResistance("player",2) var = total.." Fire resistance"
	elseif line == "4" then local _,total,_,_ = UnitResistance("player",3) var = total.." Nature resistance"
	elseif line == "5" then local _,total,_,_ = UnitResistance("player",4) var = total.." Frost resistance"
	elseif line == "6" then local _,total,_,_ = UnitResistance("player",5) var = total.." Shadow resistance"
	elseif line == "7" then local _,total,_,_ = UnitResistance("player",6) var = total.." Arcane resistance"
	elseif line == "8" then local melee = GetCombatRating(CR_CRIT_TAKEN_MELEE) local ranged = GetCombatRating(CR_CRIT_TAKEN_RANGED) local spell = GetCombatRating(CR_CRIT_TAKEN_SPELL) local Resilience = min(melee, ranged) var = Resilience.." resilience"
	elseif line == "9" then var = format("%.2f%%", GetCombatRatingBonus(6)).." Hit Rating"
	elseif line == "10" then var = format("%.2f%%", GetCombatRatingBonus(7)).." Ranged Hit Rating"
	elseif line == "11" then var = format("%.2f%%", GetCombatRatingBonus(8)).." Spell Hit Rating"
	elseif line == "12" then var = GetCombatRating(6).." Hit Rating"
	elseif line == "13" then var = GetCombatRating(7).." Ranged Hit Rating"
	elseif line == "14" then var = GetCombatRating(8).." Spell Hit Rating"
	elseif line == "15" then local mainhandSpeed, _ = UnitAttackSpeed("player") var = format("%.2f", mainhandSpeed).." Mainhand Attack Speed"
	elseif line == "16" then local _, offhandSpeed = UnitAttackSpeed("player") var = format("%.2f", offhandSpeed).." Offhand Attack Speed"
	elseif line == "17" then local rangedAttackSpeed, _, _, _, _, _ = UnitRangedDamage("player") var = format("%.2f", rangedAttackSpeed).." Ranged Attack Speed"
	elseif line == "18" then local base, casting = GetManaRegen() var = math.floor(base*5).."/"..math.floor(casting*5).." MP5"
	end
	return var
end

function PD:UpdateScheduledEvents()
	self:CancelAllScheduledEvents()
	self:ScheduleRepeatingEvent(self.UpdateText, 0.2, self)
	self:UpdateText()
end

function PD:UpdateColors()
	cd = self.db.profile.colorDamag
	damag:SetTextColor(cd.r, cd.g, cd.b)
	cd = self.db.profile.colorTyped
	typed:SetTextColor(cd.r, cd.g, cd.b)
	cd = self.db.profile.colorStats
	statone:SetTextColor(cd.r, cd.g, cd.b)
	stattwo:SetTextColor(cd.r, cd.g, cd.b)
end

function PD:UpdatePosition()
	a = self.db.profile.pos
	x = a:find("RIGHT") and -self.db.profile.posX or self.db.profile.posX
	y = a:find("TOP") and -self.db.profile.posY or self.db.profile.posY
	h = self.db.profile.align or "CENTER"

	frame:ClearAllPoints()
	frame:SetPoint(a, UIParent, self.db.profile.rpos, self.db.profile.posX, self.db.profile.posY)

	if h == "LEFT" then p1 = "TOPLEFT"
	elseif h == "RIGHT" then p1 = "TOPRIGHT"
	else p1 = "TOP"
	end
	
	damag:SetPoint(p1, frame, p1, 0, 0)
	damag:SetJustifyH(h)
	typed:SetPoint(p1, damag, p1, 0, -self.db.profile.fontSizeDamag)
	typed:SetJustifyH(h)
	statone:SetPoint(p1, typed, p1, 0, -self.db.profile.fontSizeTyped)
	statone:SetJustifyH(h)
	stattwo:SetPoint(p1, statone, p1, 0, 0-self.db.profile.fontSizeStats)
	stattwo:SetJustifyH(h)
end

function PD:UpdateFonts()
	t = SharedMedia and SharedMedia:Fetch("font", self.db.profile.fontFace) or "Fonts\\FRIZQT__.ttf" 
	damag:SetFont(t, self.db.profile.fontSizeDamag, self.db.profile.fontOutline)
	typed:SetFont(t, self.db.profile.fontSizeTyped, self.db.profile.fontOutline)
	statone:SetFont(t, self.db.profile.fontSizeStats, self.db.profile.fontOutline)
	stattwo:SetFont(t, self.db.profile.fontSizeStats, self.db.profile.fontOutline)

	if self.db.profile.fontShadow then
		damag:SetShadowOffset(1, -1)
		typed:SetShadowOffset(1, -1)
		statone:SetShadowOffset(1, -1)
		stattwo:SetShadowOffset(1, -1)
	else
		damag:SetShadowOffset(0, 0)
		typed:SetShadowOffset(0, 0)
		statone:SetShadowOffset(0, 0)
		stattwo:SetShadowOffset(0, 0)
	end

	damag:SetText("1234")
	typed:SetText("Shadow Damage")
	statone:SetText("667 Shadow resistance")
	frame:SetWidth(typed:GetWidth() > damag:GetWidth() and typed:GetWidth() or damag:GetWidth() or statone:GetWitch() or stattwo:GetWitch())
	frame:SetHeight(damag:GetHeight() + typed:GetHeight() + statone:GetHeight() + stattwo:GetHeight())
end

function PD:OnEnable()
	if not PD_Frame then
		frame = CreateFrame("Frame", "PD_Frame", UIParent)
		frame:SetFrameStrata("BACKGROUND")
		frame:SetFrameLevel(0)
	
		damag = frame:CreateFontString("PD_Damag", "OVERLAY")
		typed = frame:CreateFontString("PD_Typed", "OVERLAY")
		statone = frame:CreateFontString("PD_Statone", "OVERLAY")
		stattwo = frame:CreateFontString("PD_Stattwo", "OVERLAY")
	
		self:UpdateFonts()
		self:UpdateColors()
		self:UpdatePosition()
		self:Drag()
	end
	frame:Show()
	self:UpdateScheduledEvents()
end

function PD:Drag()
	if not self.db.profile.locked then
		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:RegisterForDrag("LeftButton")
		frame:SetScript("OnDragStart", function(this) if IsAltKeyDown() then this:StartMoving() end end)
		frame:SetScript("OnDragStop", function(this) 
			this:StopMovingOrSizing() 
			local a,b,c,d,e = this:GetPoint()
			self.db.profile.pos, self.db.profile.rpos, self.db.profile.posX, self.db.profile.posY = a, c, floor(d + 0.5), floor(e + 0.5)
		end)
	else
		frame:SetMovable(false)
		frame:EnableMouse(false)
	end
end

function PD:OnDisable()
	PD_Damag:SetText()
	PD_Typed:SetText()
	PD_Statone:SetText()
	PD_Stattwo:SetText()
	PD_Frame:Hide()
end